package datacenter

import (
	"GtDataStore/app/cmd/api/internal/svc"
	"GtDataStore/app/cmd/api/internal/types"
	"GtDataStore/app/cmd/organization/pb"
	"context"
	"github.com/jinzhu/copier"

	"github.com/zeromicro/go-zero/core/logx"
)

type ItemHistoryDataListLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewItemHistoryDataListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ItemHistoryDataListLogic {
	return &ItemHistoryDataListLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ItemHistoryDataListLogic) ItemHistoryDataList(req *types.ItemHistoryDataListResq) (resp *types.MultiAddItemHistoryDataReq, err error) {
	respList := make([]*types.ItemHistoryData, 0)
	dataList, err := l.svcCtx.OrganizationRpc.ItemHistoryDataList(l.ctx, &pb.ItemHistoryDataListReq{
		ProjectId:  req.ProjectId,
		ItemName:   req.ItemName,
		Interval:   req.Interval,
		Aggregator: req.Aggregator,
		Stime:      req.STime,
		Etime:      req.ETime,
	})
	if err != nil {
		return nil, err
	}
	for _, line := range dataList.List {
		tmp := &types.ItemHistoryData{}
		_ = copier.Copy(tmp, line)
		respList = append(respList, tmp)
	}

	return &types.MultiAddItemHistoryDataReq{List: respList}, nil
}
