package logic

import (
	"GtDataStore/app/model"
	"context"
	"github.com/jinzhu/copier"

	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetWorkingPumpByCodeLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetWorkingPumpByCodeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetWorkingPumpByCodeLogic {
	return &GetWorkingPumpByCodeLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetWorkingPumpByCodeLogic) GetWorkingPumpByCode(in *pb.DcWorkingReq) (*pb.WorkingPump, error) {
	//基础条件
	workingPumpInfo, err := l.svcCtx.WorkingPump.FindOneByCode(l.ctx, in.ProjectId, in.DeviceCode)
	if err != nil && err != model.ErrNotFound {
		logx.Errorf("not found workingUf data")
		return nil, err
	}

	resp := &pb.WorkingPump{}
	_ = copier.Copy(resp, workingPumpInfo)
	resp.CTime = workingPumpInfo.CTime.Format("2006-01-02 15:04:05")

	return resp, nil
}
