// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcWorkingChestFieldNames          = builder.RawFieldNames(&DcWorkingChest{})
	dcWorkingChestRows                = strings.Join(dcWorkingChestFieldNames, ",")
	dcWorkingChestRowsExpectAutoSet   = strings.Join(stringx.Remove(dcWorkingChestFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcWorkingChestRowsWithPlaceHolder = strings.Join(stringx.Remove(dcWorkingChestFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcWorkingChestModel interface {
		MultiInsert(ctx context.Context, datas []DcWorkingChest) (int64, error)
		Insert(ctx context.Context, data *DcWorkingChest) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcWorkingChest, error)
		Update(ctx context.Context, data *DcWorkingChest) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcWorkingChestModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcWorkingChest struct {
		Id                  int64     `db:"id"`
		ProjectId           int64     `db:"project_id"`
		DeviceCode          string    `db:"device_code"`
		Switch              int64     `db:"switch"`                // 药箱液位开关 0： 关 1： 开
		Level               float64   `db:"level"`                 // 液位高度
		AgitatorStatus      int64     `db:"agitator_status"`       // 搅拌器运行状态 0： 未运行 1：运行中
		AgitatorDuration    int64     `db:"agitator_duration"`     // 搅拌器运行时长
		AgitatorFaultStatus int64     `db:"agitator_fault_status"` // 搅拌器故障状态 0：正常 1：故障
		CTime               time.Time `db:"c_time"`
	}
)

func newDcWorkingChestModel(conn sqlx.SqlConn) *defaultDcWorkingChestModel {
	return &defaultDcWorkingChestModel{
		conn:  conn,
		table: "`dc_working_chest`",
	}
}

func (m *defaultDcWorkingChestModel) withSession(session sqlx.Session) *defaultDcWorkingChestModel {
	return &defaultDcWorkingChestModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_working_chest`",
	}
}

func (m *defaultDcWorkingChestModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcWorkingChestModel) FindOne(ctx context.Context, id int64) (*DcWorkingChest, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcWorkingChestRows, m.table)
	var resp DcWorkingChest
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcWorkingChestModel) MultiInsert(ctx context.Context, datas []DcWorkingChest) (int64, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingChestRowsExpectAutoSet)

	if bulk, err := sqlx.NewBulkInserter(m.conn, query);err == nil {
		for _, data := range datas {
			if err = bulk.Insert(data.ProjectId, data.DeviceCode, data.Switch, data.Level, data.AgitatorStatus, data.AgitatorDuration, data.AgitatorFaultStatus, data.CTime);err != nil {
				return 0, err
			}
		}

		bulk.Flush()
		return int64(len(datas)), nil
	} else {
		return 0, err
	}
}

func (m *defaultDcWorkingChestModel) Insert(ctx context.Context, data *DcWorkingChest) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingChestRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Switch, data.Level, data.AgitatorStatus, data.AgitatorDuration, data.AgitatorFaultStatus, data.CTime)
	return ret, err
}

func (m *defaultDcWorkingChestModel) Update(ctx context.Context, data *DcWorkingChest) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcWorkingChestRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Switch, data.Level, data.AgitatorStatus, data.AgitatorDuration, data.AgitatorFaultStatus, data.CTime, data.Id)
	return err
}

func (m *defaultDcWorkingChestModel) tableName() string {
	return m.table
}
