// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcWorkingRoFieldNames          = builder.RawFieldNames(&DcWorkingRo{})
	dcWorkingRoRows                = strings.Join(dcWorkingRoFieldNames, ",")
	dcWorkingRoRowsExpectAutoSet   = strings.Join(stringx.Remove(dcWorkingRoFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcWorkingRoRowsWithPlaceHolder = strings.Join(stringx.Remove(dcWorkingRoFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcWorkingRoModel interface {
		MultiInsert(ctx context.Context, datas []DcWorkingRo) (int64, error)
		Insert(ctx context.Context, data *DcWorkingRo) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcWorkingRo, error)
		Update(ctx context.Context, data *DcWorkingRo) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcWorkingRoModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcWorkingRo struct {
		Id                 int64     `db:"id"`
		ProjectId          int64     `db:"project_id"`
		DeviceCode         string    `db:"device_code"`
		WaterTemperature   float64   `db:"water_temperature"`    // 水温 摄氏度
		FeedFlow1St        float64   `db:"feed_flow_1st"`        // 一段进水流量
		ConFlow1St         float64   `db:"con_flow_1st"`         // 一段浓水流量
		ProductFlow1St     float64   `db:"product_flow_1st"`     // 一段产水流量
		FeedPressure1St    float64   `db:"feed_pressure_1st"`    // 一段进水压力
		ConPressure1St     float64   `db:"con_pressure_1st"`     // 一段浓水压力
		ProductPressure1St float64   `db:"product_pressure_1st"` // 一段产水压力
		Tmp1St             float64   `db:"tmp_1st"`              // 一段跨膜压差
		Flux1St            float64   `db:"flux_1st"`             // 一段膜通量
		Permeability1St    float64   `db:"permeability_1st"`     // 一段渗透率
		FeedFlow2Nd        float64   `db:"feed_flow_2nd"`        // 二段进水流量
		ConFlow2Nd         float64   `db:"con_flow_2nd"`         // 二段浓水流量
		ProductFlow2Nd     float64   `db:"product_flow_2nd"`     // 二段产水流量
		FeedPressure2Nd    float64   `db:"feed_pressure_2nd"`    // 二段进水压力
		ConPressure2Nd     float64   `db:"con_pressure_2nd"`     // 二段浓水压力
		ProductPressure2Nd float64   `db:"product_pressure_2nd"` // 二段产水压力
		Tmp2Nd             float64   `db:"tmp_2nd"`              // 二段压差
		Flux2Nd            float64   `db:"flux_2nd"`             // 二段通量
		Permeability2Nd    float64   `db:"permeability_2nd"`     // 二段渗透率
		FeedFlow3Th        float64   `db:"feed_flow_3th"`        // 三段进水流量
		ConFlow3Th         float64   `db:"con_flow_3th"`         // 三段浓水流量
		ProductFlow3Th     float64   `db:"product_flow_3th"`     // 三段产水流量
		FeedPressure3Th    float64   `db:"feed_pressure_3th"`    // 三段进水压力
		ConPressure3Th     float64   `db:"con_pressure_3th"`     // 三段浓水压力
		ProductPressure3Th float64   `db:"product_pressure_3th"` // 三段产水压力
		Tmp3Th             float64   `db:"tmp_3th"`              // 三段压差
		Flux3Th            float64   `db:"flux_3th"`             // 三段通量
		Permeability3Th    float64   `db:"permeability_3th"`     // 三段渗透率
		FeedWqTurbidity    float64   `db:"feed_wq_turbidity"`    // 进水浊度
		FeedWqPh           int64     `db:"feed_wq_ph"`           // 进水 PH 值
		ProductWqPh        int64     `db:"product_wq_ph"`        // 产水 PH 值
		FeedWqAl           float64   `db:"feed_wq_al"`           // 进水水质：铝
		ProductWqAl        float64   `db:"product_wq_al"`        // 产水水质：铝
		FeedWqFe           float64   `db:"feed_wq_fe"`           // 进水水质：铁
		ProductWqFe        float64   `db:"product_wq_fe"`        // 产水水质：铁
		FeedWqMn           float64   `db:"feed_wq_mn"`           // 进水水质：锰
		ProductWqMn        float64   `db:"product_wq_mn"`        // 产水水质：锰
		FeedWqSio2         float64   `db:"feed_wq_sio2"`         // 进水水质：二氧化硅
		ProductWqSio2      float64   `db:"product_wq_sio2"`      // 产水水质：二氧化硅
		FeedWqCod          float64   `db:"feed_wq_cod"`          // 进水水质：COD
		ProductWqCod       float64   `db:"product_wq_cod"`       // 产水水质：COD
		FeedWqP            float64   `db:"feed_wq_p"`            // 进水水质：磷
		ProductWqP         float64   `db:"product_wq_p"`         // 产水水质：磷
		Step               int64     `db:"step"`                 // 设备当前步序值
		FilterTime         float64   `db:"filter_time"`          // 过滤时间
		CTime              time.Time `db:"c_time"`
	}
)

func newDcWorkingRoModel(conn sqlx.SqlConn) *defaultDcWorkingRoModel {
	return &defaultDcWorkingRoModel{
		conn:  conn,
		table: "`dc_working_ro`",
	}
}

func (m *defaultDcWorkingRoModel) withSession(session sqlx.Session) *defaultDcWorkingRoModel {
	return &defaultDcWorkingRoModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_working_ro`",
	}
}

func (m *defaultDcWorkingRoModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcWorkingRoModel) FindOne(ctx context.Context, id int64) (*DcWorkingRo, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcWorkingRoRows, m.table)
	var resp DcWorkingRo
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcWorkingRoModel) MultiInsert(ctx context.Context, datas []DcWorkingRo) (int64, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingRoRowsExpectAutoSet)

	if bulk, err := sqlx.NewBulkInserter(m.conn, query); err == nil {
		for _, data := range datas {
			if err = bulk.Insert(data.ProjectId, data.DeviceCode, data.WaterTemperature, data.FeedFlow1St, data.ConFlow1St, data.ProductFlow1St, data.FeedPressure1St, data.ConPressure1St, data.ProductPressure1St, data.Tmp1St, data.Flux1St, data.Permeability1St, data.FeedFlow2Nd, data.ConFlow2Nd, data.ProductFlow2Nd, data.FeedPressure2Nd, data.ConPressure2Nd, data.ProductPressure2Nd, data.Tmp2Nd, data.Flux2Nd, data.Permeability2Nd, data.FeedFlow3Th, data.ConFlow3Th, data.ProductFlow3Th, data.FeedPressure3Th, data.ConPressure3Th, data.ProductPressure3Th, data.Tmp3Th, data.Flux3Th, data.Permeability3Th, data.FeedWqTurbidity, data.FeedWqPh, data.ProductWqPh, data.FeedWqAl, data.ProductWqAl, data.FeedWqFe, data.ProductWqFe, data.FeedWqMn, data.ProductWqMn, data.FeedWqSio2, data.ProductWqSio2, data.FeedWqCod, data.ProductWqCod, data.FeedWqP, data.ProductWqP, data.Step, data.FilterTime, data.CTime); err != nil {
				return 0, err
			}
		}

		bulk.Flush()
		return int64(len(datas)), nil
	} else {
		return 0, err
	}
}

func (m *defaultDcWorkingRoModel) Insert(ctx context.Context, data *DcWorkingRo) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingRoRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.WaterTemperature, data.FeedFlow1St, data.ConFlow1St, data.ProductFlow1St, data.FeedPressure1St, data.ConPressure1St, data.ProductPressure1St, data.Tmp1St, data.Flux1St, data.Permeability1St, data.FeedFlow2Nd, data.ConFlow2Nd, data.ProductFlow2Nd, data.FeedPressure2Nd, data.ConPressure2Nd, data.ProductPressure2Nd, data.Tmp2Nd, data.Flux2Nd, data.Permeability2Nd, data.FeedFlow3Th, data.ConFlow3Th, data.ProductFlow3Th, data.FeedPressure3Th, data.ConPressure3Th, data.ProductPressure3Th, data.Tmp3Th, data.Flux3Th, data.Permeability3Th, data.FeedWqTurbidity, data.FeedWqPh, data.ProductWqPh, data.FeedWqAl, data.ProductWqAl, data.FeedWqFe, data.ProductWqFe, data.FeedWqMn, data.ProductWqMn, data.FeedWqSio2, data.ProductWqSio2, data.FeedWqCod, data.ProductWqCod, data.FeedWqP, data.ProductWqP, data.Step, data.FilterTime, data.CTime)
	return ret, err
}

func (m *defaultDcWorkingRoModel) Update(ctx context.Context, data *DcWorkingRo) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcWorkingRoRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.WaterTemperature, data.FeedFlow1St, data.ConFlow1St, data.ProductFlow1St, data.FeedPressure1St, data.ConPressure1St, data.ProductPressure1St, data.Tmp1St, data.Flux1St, data.Permeability1St, data.FeedFlow2Nd, data.ConFlow2Nd, data.ProductFlow2Nd, data.FeedPressure2Nd, data.ConPressure2Nd, data.ProductPressure2Nd, data.Tmp2Nd, data.Flux2Nd, data.Permeability2Nd, data.FeedFlow3Th, data.ConFlow3Th, data.ProductFlow3Th, data.FeedPressure3Th, data.ConPressure3Th, data.ProductPressure3Th, data.Tmp3Th, data.Flux3Th, data.Permeability3Th, data.FeedWqTurbidity, data.FeedWqPh, data.ProductWqPh, data.FeedWqAl, data.ProductWqAl, data.FeedWqFe, data.ProductWqFe, data.FeedWqMn, data.ProductWqMn, data.FeedWqSio2, data.ProductWqSio2, data.FeedWqCod, data.ProductWqCod, data.FeedWqP, data.ProductWqP, data.Step, data.FilterTime, data.CTime, data.Id)
	return err
}

func (m *defaultDcWorkingRoModel) tableName() string {
	return m.table
}
